#include <stdio.h>
#include <math.h>

  /* Ucitava n, k i nalazi broj koji se dobiva iz n
     ciklickom rotacijom njegovih binarnih znamenki
     za k mjesta udesno.
     m = broj bitova za prikaz unsigned int.
     Koristi funkciju pow(2, nesto).
  */

int main(void)
{
    unsigned int n, m, k, rez, pot, odgovor;

    printf(" Upisi nenegativne brojeve n i k: ");
    scanf("%u %u", &n, &k);
    printf("\n n = %u, k = %u\n", n, k);

    m = sizeof(unsigned int) * 8;

    k %= m;  /* za svaki slucaj */

    rez = (unsigned int) pow(2, k);  /* potencija gdje rezemo */
        /* donji dio broja je n%rez, gornji je n/rez */
    pot = (unsigned int) pow(2, m-k);  /* multiplikator za donji dio */
    odgovor = n / rez + (n % rez) * pot;

    printf(" Udesno pomaknuti broj je %u\n", odgovor);

    return 0;
}
