#include <stdio.h>

  /* Provjera je li prirodni broj palindrom.
     Usporedjuje znamenke broja u zadanoj bazi:
     prva = zadnja i druga = predzadnja i ... */
  /* Kontraprimjer za algoritam s obratnim brojem. */

int main(void)
{
    unsigned int m = 8u * sizeof(unsigned);
    unsigned int b = ( 1u << (m - 2) ) + 1;
    unsigned int n = b + 5;

    unsigned int pot, znam1, znam2, palindrom;

    printf(" Baza = %u, Broj = %u\n", b, n);

      /* Potencija baze uz najvisu znamenku. */
    pot = 1;
    while (n / pot >= b) {
        pot *= b;
    }

    palindrom = 1;  /* DA, istina */

      /* Petlja za provjeru para znamenki. */
    while (n >= b) {
        znam1 = n / pot;
        znam2 = n % b;
        if (znam1 != znam2) {
            palindrom = 0;
            break;
        }
        n %= pot;    // Brisi prvu znamenku.
        n /= b;      // Brisi zadnju znamenku.
        pot = pot / b / b;    // Podijeli pot s b^2.
    }

    if (palindrom)
        printf(" Broj JE palindrom.\n");
    else
        printf(" Broj NIJE palindrom.\n");

    return 0;
}
