  /* Zadatak 10.1.10. (str. 114)

     Napisite funkciju koja dobiva prirodni broj n i ispisuje
     sve njegove razlicite proste faktore, svakog samo jednom.
     Napomena: sve radimo u tipu int (ignoriramo brojeve <= 0).

     Druga varijanta funkcije --- dijeljenje broja:
       - nalazi redom faktore, pocev od 2, i dijeli ih iz n,
         sve dok n ne postane 1.

     Glavni program testira funkciju za ucitani broj n.
  */

#include <stdio.h>
#include <math.h>

void ispis_prost_fakt_2(int n)
{
        /* Testira redom faktore od n, pocev od 2, i dijeli ih iz n. */

    int d;

        /* Brojevi <= 1 nemaju proste faktore (ignoriramo <= 0). */
    if (n <= 1) return;

        /* Petlja po svim mogucim faktorima od n, pocev od 2.
           Ako je d faktor, podijeli n s tim faktorom dok ide.
           Takav faktor je sigurno prost, */

    for (d = 2; n > 1; ++d)
        if (n % d == 0) {
            printf(" %d", d);

                /* Dijeli n s d, sve dok je djeljiv. */
            do
                n /= d;
            while (n % d == 0);
        }

    return;
}


int main(void)
{
    int n;

    printf(" Upisi broj n: ");
    scanf("%d", &n);

    printf("\n Prosti faktori od %d su:", n);

    ispis_prost_fakt_2(n);

    printf("\n");

    return 0;
}
