  /* Zadatak 8.5.3. (str. 93--94)

     Napisite dio programa koji ucitava prirodni broj n i ispisuje
     sve njegove razlicite proste faktore, svakog samo jednom.
     Napomena: sve radimo u tipu int (ignoriramo brojeve <= 0).

     Cetvrta varijanta algoritma --- dijeljenje broja uz dinamicku granicu:
       - nalazi redom faktore, pocev od 2, do najvise (int) sqrt(n),
         i dijeli ih iz n, te popravlja granicu prema trenutnom n,
       - na kraju, ako je preostali kvocijent > 1, obradi i njega
         kao prosti faktor.
  */

#include <stdio.h>
#include <math.h>

int main(void)
{
    int n, d, max_d;

    printf(" Upisi broj n: ");
    scanf("%d", &n);

    printf("\n Prosti faktori od %d su:", n);

        /* Petlja po svim mogucim faktorima od n, pocev od 2,
           do najvise max_d = (int) sqrt(n).
           Ako je d faktor, podijeli n s tim faktorom dok ide.
           Takav faktor je sigurno prost, */

    max_d = (int) sqrt(n);

        /* Petlja po mogucim faktorima od n od 2 do max_d. */
    for (d = 2; d <= max_d; ++d)
        if (n % d == 0) {
            printf(" %d", d);

                /* Dijeli n s d, sve dok je djeljiv. */
            do
                n /= d;
            while (n % d == 0);

                /* Popravi max_d prema trenutnom n. */
            max_d = (int) sqrt(n);
        }

        /* Ako je preostali kvocijent u n > 1, i to je prosti faktor. */
    if (n > 1)
        printf(" %d", n);

    printf("\n");

    return 0;
}
